program Full;

uses
  Messages,
  Windows,
  Main in 'Main.pas',
  Render in 'Render.pas';

begin
  ClassName := 'FullScreenClass';
  if not RegisterClass(ClassName) then
  begin
    MessageBox(0,'RegisterClass failed.',nil,MB_OK);
    exit;
  end;

  MainWindow := MakeWindow(ClassName);
  if MainWindow=0 then
  begin
    MessageBox(0,'CreateWindow failed.',nil,MB_OK);
    exit;
  end;

  InitOpenGL;
  InitSurface;
  InitLifeArea;
    
  repeat
    if PeekMessage(AMsg,0,0,0,PM_REMOVE) then
    begin
      TranslateMessage(AMsg);
      DispatchMessage(AMsg)
    end else
      RenderGL;
  until AMsg.Message = WM_QUIT;

  DoneOpenGL;
end.
