program MatrProj;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
 TMatrix=array[1..20,1..20] of single;

var
 i,j,nm,k:word;
 D:Single;
 A,B,C:TMatrix;

procedure SwapRows(const n:word);
var
 tRow:array[1..20] of single;
 i,j:word;
begin
 for i:=1 to n do
  tRow[i]:=A[1,i];
 for i:=1 to n-1 do
  for j:=1 to n do
   A[i,j]:=A[i+1,j];
 for i:=1 to n do
  A[n,i]:=tRow[i];
end;

procedure SwapRowsA(const n:word);
var
 tRow:array[1..20] of single;
 i,j:word;
begin
 for j:=1 to n do
  tRow[j]:=A[n,j];
 for i:=n downto 2 do
  for j:=1 to n do
   A[i,j]:=A[i-1,j];
 for j:=1 to n do
  A[1,j]:=tRow[j];
end;

procedure SwapCols(const n,j:word);
var
 tCol:array[1..20] of single;
 i,j1:word;
begin
 for i:=1 to n-1 do
  tCol[i]:=A[i,j];
 for j1:=j to n-1 do
  for i:=1 to n-1 do
   A[i,j1]:=A[i,j1+1];
 for i:=1 to n-1 do
  A[i,n]:=tCol[i];
end;

procedure SwapColsA(const n,j:word);
var
 tCol:array[1..20] of single;
 i,j1:word;
begin
 for i:=1 to n-1 do
  tCol[i]:=A[i,n];
 for j1:=n downto j+1 do
  for i:=1 to n-1 do
   A[i,j1]:=A[i,j1-1];
 for i:=1 to n-1 do
  A[i,j]:=tCol[i];
end;

function Determinant(const n:word):single;
label
 Ex;
var
 tRow:array[1..20] of single;
 S,Sign:single;
 j:word;
begin
 if n=2 then
 begin
  S:=A[1,1]*A[2,2] - A[2,1]*A[1,2];
  goto Ex
 end;
 for j:=1 to n do
  tRow[j]:=A[1,j];
 SwapRows(n);
 S:=0; Sign:=1;
 for j:=1 to n do
 begin
  SwapCols(n,j);
  S:=S + Sign*tRow[j]*Determinant(n-1);
  SwapColsA(n,j);
  Sign:=-1*Sign;
 end;
 SwapRowsA(n);
Ex:
 Determinant:=S
end;

procedure OutMatrix(const n:word);
var
 i,j:word;
begin
 for i:=1 to n do
 begin
  for j:=1 to n do
   write(A[i,j]:3:0);
  writeln;
 end;
 writeln;
end;


procedure InMatrixR(const n:word);
var
 i,j:word;
begin
 randomize;
 for i:=1 to n do
 begin
  for j:=1 to n do
   A[i,j]:=random(20);
   {read(A[i,j]);
  writeln;}
 end;
 OutMatrix(n);
end;

procedure InMatrix(const n:word);
var
 i,j:word;
begin
 for i:=1 to n do
 begin
  for j:=1 to n do
   read(A[i,j]);
  end;
end;

begin
 readln(nm);
 Writeln('Matrix A (nXn)');
 InMatrix(nm);
 D:=Determinant(nm);
 writeln(D);
 OutMatrix(nm);
 readln;
 readln;
end.

